<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class BotFeedbackMessage extends \Google\Protobuf\Internal\Message
{
    


    protected $messageKey = null;
    


    protected $kind = null;
    


    protected $text = null;
    


    protected $kindNegative = null;
    


    protected $kindPositive = null;
    


    protected $kindReport = null;
    


    protected $sideBySideSurveyMetadata = null;

    














    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getMessageKey()
    {
        return $this->messageKey;
    }

    public function hasMessageKey()
    {
        return isset($this->messageKey);
    }

    public function clearMessageKey()
    {
        unset($this->messageKey);
    }

    




    public function setMessageKey($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\MessageKey::class);
        $this->messageKey = $var;

        return $this;
    }

    



    public function getKind()
    {
        return isset($this->kind) ? $this->kind : 0;
    }

    public function hasKind()
    {
        return isset($this->kind);
    }

    public function clearKind()
    {
        unset($this->kind);
    }

    




    public function setKind($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\BotFeedbackMessage\BotFeedbackKind::class);
        $this->kind = $var;

        return $this;
    }

    



    public function getText()
    {
        return isset($this->text) ? $this->text : '';
    }

    public function hasText()
    {
        return isset($this->text);
    }

    public function clearText()
    {
        unset($this->text);
    }

    




    public function setText($var)
    {
        GPBUtil::checkString($var, True);
        $this->text = $var;

        return $this;
    }

    



    public function getKindNegative()
    {
        return isset($this->kindNegative) ? $this->kindNegative : 0;
    }

    public function hasKindNegative()
    {
        return isset($this->kindNegative);
    }

    public function clearKindNegative()
    {
        unset($this->kindNegative);
    }

    




    public function setKindNegative($var)
    {
        GPBUtil::checkUint64($var);
        $this->kindNegative = $var;

        return $this;
    }

    



    public function getKindPositive()
    {
        return isset($this->kindPositive) ? $this->kindPositive : 0;
    }

    public function hasKindPositive()
    {
        return isset($this->kindPositive);
    }

    public function clearKindPositive()
    {
        unset($this->kindPositive);
    }

    




    public function setKindPositive($var)
    {
        GPBUtil::checkUint64($var);
        $this->kindPositive = $var;

        return $this;
    }

    



    public function getKindReport()
    {
        return isset($this->kindReport) ? $this->kindReport : 0;
    }

    public function hasKindReport()
    {
        return isset($this->kindReport);
    }

    public function clearKindReport()
    {
        unset($this->kindReport);
    }

    




    public function setKindReport($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\BotFeedbackMessage\ReportKind::class);
        $this->kindReport = $var;

        return $this;
    }

    



    public function getSideBySideSurveyMetadata()
    {
        return $this->sideBySideSurveyMetadata;
    }

    public function hasSideBySideSurveyMetadata()
    {
        return isset($this->sideBySideSurveyMetadata);
    }

    public function clearSideBySideSurveyMetadata()
    {
        unset($this->sideBySideSurveyMetadata);
    }

    




    public function setSideBySideSurveyMetadata($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\BotFeedbackMessage\SideBySideSurveyMetadata::class);
        $this->sideBySideSurveyMetadata = $var;

        return $this;
    }

}

